# !/usr/bin/perl
#########################################################
# Global Variables 
$CountChars=0;
$CountAFMs=0;
$CountKerns=0;

#########################################################
# Subroutines
sub Max {
    local($first)=0;
    local($second)=0;
    $first=$_[0];
    $second=$_[1];
    if ($first > $second) { return $first; }
    else { return $second; }
    }

sub Min {
    local($first)=0;
    local($second)=0;
    $first=$_[0];
    $second=$_[1];
    if ($first > $second) { return $second; }
    else { return $first; }
    }
    
sub AMax {
    local($first)=0;
    local($second)=0;
    $first=$_[0];
    $second=$_[1];
    if (abs($first) > abs($second)) { return $first; }
    else { return $second; }
    }

sub AMin {
    local($first)=0;
    local($second)=0;
    $first=$_[0];
    $second=$_[1];
    if (abs($first) > abs($second)) { return $second; }
    else { return $first; }
    }
    
sub tan {
    return (sin($_[0]*3.1415926/180) / cos($_[0]*3.1415926/180));
    }

sub WritePL {
local($pos)=$_[0];
if ($pos >= 0) {
	local($wd)=$_[1];
	local($ht)=$_[2];
	local($dp)=$_[3];
	local($ic)=$_[4];
	local($name)=$_[5];
	$dp=Max($dp,0);
	print PL <<EOD;
(CHARACTER D $pos (COMMENT $name)
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   )
EOD
}
}

sub Simple {
local($pos)=$_[0];
local($name)=$_[1];
local($hoffset)=$_[2];
local($voffset)=$_[3];
if ($font{$name} ne "") {
	$fo=$font{$name};
	$co=$afmcode{$name};
	$wd=$afmwx{$name};	
	$ht=&AMin($afmbfour{$name},$MaxHeight);
	$dp=&AMin($afmbtwo{$name},$MaxDepth);
	$dp=&Max($dp,0);
	$it=0;
	print OVP <<EOD;
(CHARACTER H $pos
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   (MAP
      (SELECTFONT D $fo)
EOD
	if ($hoffset != 0) {
	print OVP <<EOD;
      (MOVERIGHT R $hoffset)
EOD
}
	if ($voffset != 0) {
	$voffset=-$voffset;
	print OVP <<EOD;
      (MOVEDOWN R $voffset)
EOD
}
	print OVP <<EOD;
      (SETCHAR D $co)
      )
   )
EOD
	$CountChars++;
	}
}

sub AddSpace {
local($pos)=$_[0];
local($left)=$_[1];
local($right)=$_[2];
local($name)=$_[3];
if ($font{$name} ne "") {
	$fo=$font{$name};
	$co=$afmcode{$name};
	$wd=$afmwx{$name}+$left+$right;
	$ht=&AMin($afmbfour{$name},$MaxHeight);
	$dp=&AMin($afmbtwo{$name},$MaxDepth);
	$dp=&Max($dp,0);
	$it=0;
	print OVP <<EOD;
(CHARACTER H $pos
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   (MAP
      (SELECTFONT D $fo)
      (MOVERIGHT R $left)
      (SETCHAR D $co)
      )
   )
EOD
	$CountChars++;
	}
}

sub Adjacent {
local($pos)=$_[0];
local($name_)=$_[1];
local($name__)=$_[2];
local($move)=$_[3];
if (($font{$name_} ne "") && ($font{$name__} ne "")) {
	$fo_=$font{$name_};
	$co_=$afmcode{$name_};
	$wd_=$afmwx{$name_};
	$ht_=&AMin($afmbfour{$name_},$MaxHeight);
	$dp_=&AMin($afmbtwo{$name_},$MaxDepth);
	$dp_=&Max($dp_,0);
	$it_=0;
	$fo__=$font{$name__};
	$co__=$afmcode{$name__};
	$wd__=$afmwx{$name__};
	$ht__=&AMin($afmbfour{$name__},$MaxHeight);
	$dp__=&AMin($afmbtwo{$name__},$MaxDepth);
	$dp__=&Max($dp__,0);
	$it__=0;

	$wd=$wd_+$wd__-$move;
	$ht=&Max($ht_,$ht__);
	$dp=&Max($dp_,$dp__);
	$it=0;
	$moveright=-$move;
	if (abs($moveright) < 0.001) { $moveright = 0; }
	print OVP <<EOD;
(CHARACTER H $pos
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   (MAP
      (SELECTFONT D $fo_)
      (SETCHAR D $co_)
      (MOVERIGHT R $moveright)
      (SELECTFONT D $fo__)
      (SETCHAR D $co__)
      )
   )
EOD
	$CountChars++;
	}
}

sub FixAccent {
local($pos)=$_[0];
local($name)=$_[1];
local($accent)=$_[2];
local($accheight)=$_[3];
local($acctype)=$_[4];
local($asif)=$_[5];
local($accent_asif)=$_[6];
local($is_sub)=$_[7];
if (($font{$name} ne "") && ($font{$accent} ne "") && ($font{$asif} ne "") && ($font{$accent_asif} ne "")) {
	$fo=$font{$name};
	$co=$afmcode{$name};
	$wd=$afmwx{$name};
	$ht=$afmbfour{$name};
	$dp=$afmbtwo{$name};
	$dp=&Max($dp,0);
	$it=0;
	$foasif=$font{$asif};
	$coasif=$afmcode{$asif};
	$wdasif=$afmwx{$asif};
	$htasif=$afmbfour{$asif};
	$dpasif=$afmbtwo{$asif};
	if ($dpasif < 0) { $dpasif=0; }
	$itasif=0;
	$foac=$font{$accent};
	$coac=$afmcode{$accent};
	$wdac=$afmwx{$accent};
	$htac=$afmbfour{$accent};
	$dpac=$afmbtwo{$accent};
	if ($dpac < 0) { $dpac=0; }
	$itac=0;
	if ($is_sub eq "FIX_DP") { $vof=0; }
	elsif ($is_sub eq "ZERO_DP") { $vof=$afmbfour{$accent}+$Epsilon; }
	elsif ($is_sub eq "NOT_SUB") { $vof=($afmbtwo{$accent}-$accheight-$Epsilon); }
	if ($acctype eq "CENTER") { 
		$hof=$afmbone{$asif}+.5*($afmbthree{$asif}-
			$afmbone{$asif})-($afmbone{$accent_asif}+
			.5*($afmbthree{$accent_asif}-$afmbone{$accent_asif}));
		$hof=$hof+(($afmbtwo{$accent_asif}-$vof-.5*($afmbfour{$asif}-$afmbtwo{$asif}))*&tan($Angle));
		}
	elsif ($acctype eq "REV") { 
		$hof=$afmwx{$name}-$afmwx{$asif}+$afmbone{$asif}+.5*($afmbthree{$asif}-
			$afmbone{$asif})-($afmbone{$accent_asif}+
			.5*($afmbthree{$accent_asif}-$afmbone{$accent_asif}));
		$hof=$hof+(($afmbtwo{$accent_asif}-$vof-.5*($afmbfour{$asif}-$afmbtwo{$asif}))*&tan($Angle));
		}
	elsif ($acctype eq "LLAP") { 
		$hof=0;
		}
	$ht=&Max($afmbfour{$accent}-$vof,$ht); 
	if (abs($hof) < 0.001) { $hof = 0; }
	if (abs($vof) < 0.001) { $vof = 0; }
	$ht=&AMin($ht,$MaxHeight);
	$dp=&AMin($dp,$MaxDepth);
	print OVP <<EOD;
(CHARACTER H $pos
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   (MAP
      (PUSH)
      (MOVERIGHT R $hof)
      (MOVEDOWN R $vof)
      (SELECTFONT D $foac)
      (SETCHAR D $coac)
      (POP)
      (SELECTFONT D $fo)
      (SETCHAR D $co)
      )
   )
EOD
	$CountChars++;
	}
}

sub DblFixAccent {
local($pos)=$_[0];
local($name)=$_[1];
local($accent_)=$_[2];
local($accent)=$_[3];
local($accheight)=$_[4];
local($acctype)=$_[5];
local($asif)=$_[6];
local($is_sub)=$_[7];
local($acc_voffset)=$_[8];
if (($font{$name} ne "") && ($font{$accent} ne "") && ($font{$accent_} ne "") && ($font{$asif} ne "")) {
	$fo=$font{$name};
	$co=$afmcode{$name};
	$wd=$afmwx{$name};
	$ht=$afmbfour{$name};
	$dp=$afmbtwo{$name};
	if ($dp < 0) { $dp=0; }
	$it=0;
	$foasif=$font{$asif};
	$coasif=$afmcode{$asif};
	$wdasif=$afmwx{$asif};
	$htasif=$afmbfour{$asif};
	$dpasif=$afmbtwo{$asif};
	if ($dpasif < 0) { $dpasif=0; }
	$itasif=0;
	$foac=$font{$accent};
	$coac=$afmcode{$accent};
	$wdac=$afmwx{$accent};
	$htac=$afmbfour{$accent};
	$dpac=$afmbtwo{$accent};
	if ($dpac < 0) { $dpac=0; }
	$foac_=$font{$accent_};
	$coac_=$afmcode{$accent_};
	$wdac_=$afmwx{$accent_};
	$htac_=$afmbfour{$accent_};
	$dpac_=$afmbtwo{$accent_};
	if ($dpac_ < 0) { $dpac_=0; }
	$itac_=0;
	if ($is_sub eq "FIX_DP") { $vof=0; }
	elsif ($is_sub eq "ZERO_DP") { $vof=$afmbfour{$accent}+$Epsilon; }
	elsif ($is_sub eq "NOT_SUB") { $vof=$afmbtwo{$accent}-($accheight+$Epsilon); }
	if ($acctype eq "CENTER") {
		$hof=$afmbone{$asif}+.5*($afmbthree{$asif}-
		$afmbone{$asif})-($afmbone{$accent}+
		.5*($afmbthree{$accent}-$afmbone{$accent}));
		$hof=$hof+(($afmbtwo{$accent}-$vof-.5*($afmbfour{$asif}-$afmbtwo{$asif}))*&tan($Angle));
		}
	elsif ($acctype eq "LLAP") {
		$hof=0;
		}
	if (($is_sub eq "FIX_DP") || ($is_sub eq "ZERO_DP")) { $vof_=$afmbtwo{$accent_}-($accheight+$Epsilon); }
	elsif ($is_sub eq "NOT_SUB") { $vof_=$afmbtwo{$accent_}-($accheight+2*$Epsilon+$afmbfour{$accent}-$afmbtwo{$accent})+$acc_voffset; }
	if ($acctype eq "CENTER") {
		$hof_=$afmbone{$asif}+.5*($afmbthree{$asif}-
		$afmbone{$asif})-($afmbone{$accent_}+
		.5*($afmbthree{$accent_}-$afmbone{$accent_}));
		$hof_=$hof_+(($afmbtwo{$accent_}-$vof_-.5*($afmbfour{$asif}-$afmbtwo{$asif}))*&tan($Angle));
		}
	elsif ($acctype eq "LLAP") {
		$hof_=0;
		}
	$ht=($afmbfour{$accent_}-$vof_ > $ht)? $afmbfour{$accent_}-$vof_ : $ht; 
	if (abs($hof) < 0.001) { $hof = 0; }
	if (abs($vof) < 0.001) { $vof = 0; }
	if (abs($hof_) < 0.001) { $hof_ = 0; }
	if (abs($vof_) < 0.001) { $vof_ = 0; }
	$ht=&AMin($ht,$MaxHeight);
	$dp=&AMin($dp,$MaxDepth);
	print OVP <<EOD;
(CHARACTER H $pos
   (CHARWD R $wd)
   (CHARHT R $ht)
   (CHARDP R $dp)
   (CHARIC R $it)
   (MAP
      (PUSH)
      (MOVERIGHT R $hof)
      (MOVEDOWN R $vof)
      (SELECTFONT D $foac)
      (SETCHAR D $coac)
      (POP)
      (PUSH)
      (MOVERIGHT R $hof_)
      (MOVEDOWN R $vof_)
      (SELECTFONT D $foac_)
      (SETCHAR D $coac_)
      (POP)
      (SELECTFONT D $fo)
      (SETCHAR D $co)
      )
   )
EOD
	$CountChars++;
	}
}

#########################################################
# Step 0
# Initialize variables
$NumberOfAFMFiles=0;
$XHeight=0.459;
$CapHeight=0.662;
$Epsilon=0.1;
$Angle=0;
$MaxHeight=10000;
$MaxDepth=10000;

#########################################################
## Step 1
# Read the AFM files and write PL files
foreach $fn (@ARGV) {
if ($fn =~ m/[a-zA-Z0-9_]\.[Aa][Ff][Mm]/) { 
	$AFMFile[$NumberOfAFMFiles]=$fn;
	$NumberOfAFMFiles++;
	}
elsif ($fn =~ m/[a-zA-Z0-9]+\.[Cc][Ff][Gg]/) { 
	$ConfigFile=$fn;
	}
elsif ($fn =~ m/[a-zA-Z0-9]+\.[Oo][Vv][Pp]/) { 
	$OVPFile=$fn;
	}
elsif ($fn =~ m/([0-9]+)\.[Xx][Hh][Tt]/) { 
	$Xheight=$1/1000;
	}
elsif ($fn =~ m/([0-9]+)\.[Cc][Hh][Tt]/) { 
	$CapHeight=$1/1000;
	}
elsif ($fn =~ m/([0-9]+)\.[Aa][Nn][Gg]/) { 
	$Angle=$1/1000;
	}
elsif ($fn =~ m/([0-9]+)\.[Mm][Hh][Tt]/) { 
	$MaxHeight=$1/1000;
	}
elsif ($fn =~ m/([0-9]+)\.[Mm][Dd][Pp]/) { 
	$MaxDepth=$1/1000;
	}
elsif ($fn =~ m/([A-Za-z]+)\.[Xx][Hh][Tt]/) { 
	$XheightLetter=$1;
	}
elsif ($fn =~ m/([A-Za-z]+)\.[Cc][Hh][Tt]/) { 
	$CapHeightLetter=$1;
	}
}

print STDERR "Reading AFM files";

foreach $ifile (0 .. $NumberOfAFMFiles-1) {
	open(AFM,$AFMFile[$ifile]) || print STDERR "Cannot open AFM file ".$AFMFile[$ifile]."\n";
	print STDERR ".";
	$temp=$AFMFile[$ifile]; $temp =~ s/\.[Aa][Ff][Mm]/.pl/;
	open(PL,'>'.$temp) || die "Cannot open PL file ".$temp." for write\n";
	
	while(<AFM>) {
	if (m/ItalicAngle ([-.0-9]+)/) {
		$ItalicAngle[$ifile]=$1;
		}
	elsif (m/^C\s+([-.0-9]+)\s?; WX ([-.0-9]+)\s?; N ([.a-zA-Z0-9]+)\s?; B ([-.0-9]+) ([-.0-9]+) ([-.0-9]+) ([-.0-9]+)\s?;/) {
		$code=$1;
		$wx=$2;
		$name=$3;
		$bone=$4;
		$btwo=$5;
		$bthree=$6;
		$bfour=$7;
		if ($font{$name} eq "") { 
			$font{$name}=sprintf("%d",$ifile);
			$afmcode{$name}=$code;
			$afmwx{$name}=$wx/1000;
			$afmbone{$name}=$bone/1000;
			$afmbtwo{$name}=$btwo/1000;
			$afmbthree{$name}=$bthree/1000;
			$afmbfour{$name}=$bfour/1000;
			&WritePL($code,$afmwx{$name},$afmbfour{$name},$afmbtwo{$name},0,$name);
			}
		$HasAtLeastOneChar[$ifile]=1;
		}
	elsif (m/^KPX ([.a-zA-Z]+) ([.a-zA-Z]+) ([-.0-9]+)/) {
		$kerning{$1."-".$2}=$3/1000;
		$totheleftof{$2} .= ":".$1;
		$totherightof{$1} .= ":".$2;
		}
	}
	close(AFM);
	close(PL);
}
#if ($XHeightLetter ne "") {
#	if ($font{$XHeightLetter} ne "") {
#		$XHeight = $afmwx{$XHeightLetter}/1000;
#	}
#}
#if ($CapHeightLetter ne "") {
#	if ($font{$CapHeightLetter} ne "") {
#		$CapHeight = $afmwx{$CapHeightLetter}/1000;
#	}
#}

#########################################################
## Step 2
# Read the CFG file a first time and resolve kerning
open(CFG,$ConfigFile) || print STDERR "Cannot open config file ".$ConfigFile." for first read\n";

print STDERR "\nReading CFG file for the first time";

while (<CFG>) {
	if (m/^([0-9A-Fa-f]{4}) .*\#KRN=([A-Za-z]+)/) { $code=$1; $name=$2; print STDERR "+";
			foreach $candidate (split /:/,$totherightof{$name}) {
				$kerning{"*$code-$candidate"}=$kerning{"$name-$candidate"}; 
				$totheleftof{$candidate} .= ":*".$code;
			}
			foreach $candidate (split /:/,$totheleftof{$name}) {
				$kerning{"$candidate-*$code"}=$kerning{"$candidate-$name"}; 
				$totherightof{$candidate} .= ":*".$code;
			}	
	}
	elsif (m/^[0-9A-Fa-f]{4} .*\#KRN(LEFT|RIGHT)=[A-Za-z]+/) {
		if (m/^([0-9A-Fa-f]{4}) .*\#KRNLEFT=([A-Za-z]+)/) { $code=$1; $name=$2; print STDERR "<";
			foreach $candidate (split /:/,$totheleftof{$name}) {
				$kerning{"$candidate-*$code"}=$kerning{"$candidate-$name"}; 
				$totherightof{$candidate} .= ":*".$code;
			}	
		}
		if (m/^([0-9A-Fa-f]{4}) .*\#KRNRIGHT=([A-Za-z]+)/) { $code=$1; $name=$2; print STDERR ">";
			foreach $candidate (split /:/,$totherightof{$name}) {
				$kerning{"*$code-$candidate"}=$kerning{"$name-$candidate"}; 
				$totheleftof{$candidate} .= ":*".$code;
			}
		}
	}
	elsif (m/^([0-9A-Fa-f]{4}) N ([A-Za-z]+)/) { $code=$1; $name=$2; print STDERR ".";
		foreach $candidate (split /:/,$totherightof{$name}) {
			$kerning{"*$code-$candidate"}=$kerning{"$name-$candidate"}; 
			$totheleftof{$candidate} .= ":*".$code;
		}
		foreach $candidate (split /:/,$totheleftof{$name}) {
			$kerning{"$candidate-*$code"}=$kerning{"$candidate-$name"}; 
			$totherightof{$candidate} .= ":*".$code;
		}	
	}
}
close(CFG);

#########################################################
## Step 3
# Read the CFG file and write the OVP file

print STDERR "\nReading CFG for a second time and writing OVP file\n";

open(CFG,$ConfigFile) || print STDERR "Cannot open config file ".$ConfigFile."\n";
open(OVP,'>0000temp') || print STDERR "Cannot open 0000temp file for write\n";
while(<CFG>) {
	print STDERR ".";
	
	if (m/^VTITLE (.+)/) { print OVP "(VTITLE $1)\n"; }
	elsif (m/^EPSILON (.+)/) { $Epsilon=$1; }
	elsif (m/^FAMILY (.+)/) { print OVP "(FAMILY $1)\n"; }
	elsif (m/^CODINGSCHEME (.+)/) { print OVP <<EOD;
(CODINGSCHEME $1)
(DESIGNSIZE R 10.0)
(COMMENT DESIGNSIZE IS IN POINTS)
(COMMENT OTHER SIZES ARE MULTIPLES OF DESIGNSIZE)
(SEVENBITSAFEFLAG TRUE)
EOD
	}
	elsif (m/^SLANT (.+)/) { print OVP "(FONTDIMEN\n   (SLANT R $1)\n"; }
	elsif (m/^SPACE (.+)/) { $space=$1; print OVP "   (SPACE R $1)\n"; }
	elsif (m/^STRETCH (.+)/) { print OVP "   (STRETCH R $1)\n"; }
	elsif (m/^SHRINK (.+)/) { print OVP "   (SHRINK R $1)\n"; }
	elsif (m/^XHEIGHT (.+)/) { print OVP "   (XHEIGHT R $1)\n"; }
	elsif (m/^QUAD (.+)/) { print OVP "   (QUAD R $1)\n"; }
	elsif (m/^EXTRASPACE (.+)/) { print OVP "   (EXTRASPACE R $1)\n   )\n"; 
		foreach $ifile (0 .. $NumberOfAFMFiles-1) {
			if ($HasAtLeastOneChar[$ifile] != 0) {
				$temp = $AFMFile[$ifile];
				$temp =~ s/.[Aa][Ff][Mm]//;
				$ttemp = sprintf("%d",$ifile);
				$CountAFMs++;
				print OVP <<EOD;
(MAPFONT D $ttemp
   (FONTNAME $temp)
   (FONTAT R 1.0)
   (FONTDSIZE R 10.0)
   )
EOD
			}
		}
		print OVP "(LIGTABLE\n";
		$temp=""; $start=0; $atleastone=0;
		foreach $pair (sort keys (%kerning)) {
			if ($pair =~ m/\*([0-9A-Fa-f]{4})-\*([0-9A-Fa-f]{4})/) {
				$expr=$kerning{$pair};
				if ($expr ne "0") {
					if ($1 ne $temp) { 
						if ($start != 0) { print OVP "   (STOP)\n"; }
						print OVP "   (LABEL H $1)\n   (KRN H $2 R $expr)\n"; 						
						$start=1;
					        $atleastone=1; 
					        $temp=$1;
					}
					else { print OVP "   (KRN H $2 R $expr)\n"; }
					$CountKerns++;
				}
			}
		}
		if ($atleastone != 0) { print OVP "   (STOP)\n"; }
		print OVP "   )\n";
	}
	elsif (m/^([0-9A-Fa-f]{4}) N ([0-9A-Za-z]+)/) { 
		$code=$1;
		$name=$2;
		# Check first if there is an offset
		$hoffset=0.0;
		$voffset=0.0;
		if (m/\#HOFFSET=([-0-9]+)/) { $hoffset=$1/1000; }
		if (m/\#VOFFSET=([-0-9]+)/) { $voffset=$1/1000; }
		&Simple($code,$name,$hoffset,$voffset); 
		}
	elsif (m/^([0-9A-Fa-f]{4}) ADDSPACE ([0-9.]+) ([0-9.]+) ([A-Za-z0-9]+)/) { &AddSpace($1,$2*$space,$3*$space,$4); }
	elsif (m/^([0-9A-Fa-f]{4}) DBL([A-Z]+) ([A-Za-z0-9]+) ([A-Za-z0-9]+) ([A-Za-z0-9]+)/) { 
		$code=$1;
		$type=$2;
		$letter=$3;
		$accenta=$4;
		$accentb=$5;
		# Check first if there is an alias
		if (m/\#LETTERLIKE=([A-Za-z0-9]+)/) { $asif=$1; } else { $asif=$letter; }
		# Check if there is a vertical correction for the accent height
		if (m/\#ACCENTOFFSET=([-0-9.]+)/) { $acc_voffset=$1/1000; } else { $acc_voffset=0; }
		#
		if ($type eq "XHAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$XHeight,"CENTER",$asif,"NOT_SUB",$acc_voffset); }
		elsif ($type eq "CHAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$CapHeight,"CENTER",$asif,"NOT_SUB",$acc_voffset); }
		elsif ($type eq "XHLLAP") { &DblFixAccent($code,$letter,$accenta,$accentb,$XHeight,"LLAP",$asif,"NOT_SUB",$acc_voffset); }
		elsif ($type eq "CHLLAP") { &DblFixAccent($code,$letter,$accenta,$accentb,$CapHeight,"LLAP",$asif,"NOT_SUB",$acc_voffset); } 
		elsif ($type eq "XHSUBZERODPAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$XHeight,"CENTER",$asif,"ZERO_DP",0); }
		elsif ($type eq "CHSUBZERODPAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$CapHeight,"CENTER",$asif,"ZERO_DP",0); }
		elsif ($type eq "XHSUBFIXDPAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$XHeight,"CENTER",$asif,"FIX_DP",0); }
		elsif ($type eq "CHSUBFIXDPAC") { &DblFixAccent($code,$letter,$accenta,$accentb,$CapHeight,"CENTER",$asif,"FIX_DP",0); }
		}
	elsif (m/^([0-9A-Fa-f]{4}) ADJ ([A-Za-z0-9]+) ([A-Za-z0-9]+) \#MOVELEFT=([-0-9.]+)/) {
		&Adjacent($1,$2,$3,$4/1000); 
		}
	elsif (m/^([0-9A-Fa-f]{4}) ([A-Z]+) ([A-Za-z0-9]+) ([A-Za-z0-9]+)/) { 
		$code=$1;
		$type=$2;
		$letter=$3;
		$accent=$4;
		$accent_type="NOT_SUB";
		# Check first if there is an alias
		if (m/\#LETTERLIKE=([A-Za-z0-9]+)/) { $asif=$1; $accent_type="CENTER"; }
		elsif (m/\#LETTERREVLIKE=([A-Za-z0-9]+)/) { $asif=$1; $accent_type="REV"; }
		else { $asif=$letter; $accent_type="CENTER"; }
		if (m/\#ACCENTLIKE=([A-Za-z0-9]+)/) { $accent_asif=$1; } else { $accent_asif=$accent; }
		#
		if ($type eq "XHAC") { &FixAccent($code,$letter,$accent,$XHeight,$accent_type,$asif,$accent_asif,"NOT_SUB"); }
		elsif ($type eq "CHAC") { &FixAccent($code,$letter,$accent,$CapHeight,$accent_type,$asif,$accent_asif,"NOT_SUB"); }
		elsif ($type eq "VARAC") { &FixAccent($code,$letter,$accent,$afmbfour{$letter},$accent_type,$asif,$accent_asif,"NOT_SUB"); }
		elsif ($type eq "XHLLAP") { &FixAccent($code,$letter,$accent,$XHeight,"LLAP",$asif,$accent_asif,"NOT_SUB"); }
		elsif ($type eq "CHLLAP") { &FixAccent($code,$letter,$accent,$CapHeight,"LLAP",$asif,$accent_asif,"NOT_SUB"); } 
		elsif ($type eq "ADJ") { &Adjacent($code,$letter,$accent,0); } 
		elsif ($type eq "SUBZERODPAC") { &FixAccent($code,$letter,$accent,$XHeight,$accent_type,$asif,$accent_asif,"ZERO_DP");  } 
		elsif ($type eq "SUBFIXDPAC") { &FixAccent($code,$letter,$accent,$XHeight,$accent_type,$asif,$accent_asif,"FIX_DP");  } 
		}
}
close(CFG);
close(OVP);

print STDERR "\nThis font uses $CountAFMs real fonts, has $CountChars characters and $CountKerns kerning pairs";

print STDERR "\nChecking...";

open(TEMP,'0000temp') || print STDERR "Cannot open TEMP file 0000temp for read\n";
open(OVP,'>'.$OVPFile) || print STDERR "Cannot open OVP file ".$OVPFile." for write\n";

while(<TEMP>) {
                if (m/LABEL H ([0-9A-F]+)/) { $label{$1}=1; }
        elsif (m/KRN H ([0-9A-F]+)/) { $kern{$1}=1; }
        elsif (m/CHARACTER H ([0-9A-F]+)/) {
                $kern{$1}=0;
                $label{$1}=0; 
                }
}
foreach $key (sort keys %label) {
        if ($label{$key} == 1) { $labelstoerase{$key} = 1; }
                }
foreach $key (sort keys %kern) {
	if ($kern{$key} == 1) { $kernstoerase{$key} = 1; }
                }
            

close(TEMP);

print STDERR "\nRechecking...\n";

open(TEMP,'0000temp') || print STDERR "Cannot open TEMP file 0000temp for second read\n";

$enter_kill_label_mode = 0;
# 0 means print
# 1 means don't print
# 2 means don't print this one, but print next

while(<TEMP>) {
        # kill_label_mode: 0 is normal, 1 is kill, 2 is kill this line and then enter again normal mode
        if (m/LABEL H ([0-9A-F]+)/) { $label=$1;
        	foreach $key (sort keys %labelstoerase) {
			if ($label eq $key) { $enter_kill_label_mode = 1; print OVP "   (COMMENT Just killed LABEL $label)\n" ; }
			}
		}
        elsif (m/\(STOP\)/) { if ($enter_kill_label_mode == 1) { $enter_kill_label_mode = 2; } }
        elsif (m/KRN H ([0-9A-F]+)/) { $kern=$1; if ($enter_kill_label_mode != 1) {
        	foreach $key (sort keys %kernstoerase) {
			if ($kern eq $key) { $enter_kill_label_mode = 2;  print OVP "   (COMMENT Just killed KERN $kern)\n" ; }
			}
			}
	        }
	
	if ($enter_kill_label_mode == 0) { print OVP $_; }
	elsif ($enter_kill_label_mode == 2) { $enter_kill_label_mode=0; }
}

close(TEMP);
close(OVP);
#unlink("0000temp");   
